<?php
/***
 * New Threads
  ------
 * Created by: tyroklone
  ------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License, version 3, as 
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, visit <http://www.gnu.org/licenses/gpl.html>
 * 
 * Read More @License.txt File
***/

// disallow direct loading of this file
if (!defined("IN_MYBB")) {
  die("Direct loading of this file is not allowed.");
}

function newthreads_get_info() { 
   global $db, $mybb, $lang;
   $lang->load('newthreads');

   $name = "<span style=\"color: #279025; text-shadow: 1px 1px 1px #000000;\">New Threads</span>";

   $author = "</a></small></i><a href=\"http://ncgforum.byethost14.com\" title=\"NcgForum\"><span style=\"color: #279025;\">tyroklone</span></a><i><small><a>";

  return array( 
  "name" => $name, 
  "description" => $lang->nt_desc, 
  "website" => $lang->nt_site, 
  "author" => $author, 
  "authorsite" => $lang->nt_author_site, 
  "version" => $lang->nt_ver, 
  "codename" => $lang->nt_codename, 
  "compatibility" => $lang->nt_compat,
  );
}

function newthreads_get_is_installed()
{
   global $db;

    $query = $db->simple_select("settinggroups", "*", "name='newthreads'");
    if($db->num_rows($query))
    {
        return TRUE;
    }
    return FALSE;
}

function newthreads_get_uninstall()
{
   global $db;

    $query = $db->simple_select("settinggroups", "*", "name='newthreads'");
    $gid = $db->fetch_field($query, "gid");
    if(!$gid)
    {
        return;
    }
    $db->delete_query("settinggroups", "gid=" . $gid);
    $db->delete_query("settings", "gid=" . $gid);
    rebuild_settings();   
}

function newthreads_get_activate() 
{
   global $db;

    $new_template_group = array(
        "prefix" => "newthreads",
        "title" => "NewThreads (NT)",
    );

    $db->insert_query("templategroups", $new_template_group);

    $new_template['newthreads'] = '<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<thead>
<tr>
<td class="thead" colspan="3"><i class="fa fa-bars" style="color: #ffffff; float: left;"></i>
<div align="center"><strong>{$lang->nt_newthreads}</strong></div>
</td>
</tr>
</thead>
{$n_threads}
</table>
<div align="{$nt_align}">{$multipage}</div><br />';
    $new_template['newthreads_thread'] = '<tr>
{$author_avatar}
{$lastposter_avatar}
<td valign="middle" class="{$trow}"><strong><a href="{$threadlink}">{$thread[\'subject\']}</a></strong>
<br />{$lang->nt_forum} <a href="{$thread[\'forumlink\']}">{$thread[\'forum\']}</a><br />{$lang->nt_by} {$thread[\'author\']}<br />{$relativetime}<br /><strong>&raquo;</strong> {$lang->nt_replies} {$thread[\'replies\']}<br /><strong>&raquo;</strong> {$lang->nt_views} {$thread[\'views\']}
</td>
<td valign="middle" align="right" width="1" class="{$trow}"><a href="{$lastpostlink}"><i class="fa fa-chevron-right" style="color: #000000;"></i></a>
</td>
</tr>';

    $new_template['newthreads_avatar'] = '<td align="center" width="1" class="{$trow}"><img src="{$avatarurl}" width="{$avatar_size}" height="{$avatar_size}" alt="{$avatarurl}" /></td>';
        $new_template['newthreads_headerinclude'] = '<script type="text/javascript">
$(document).ready(function() {
     $("#refresh_new_threads").load(" #refresh_new_threads");
   var refreshId = setInterval(function() {
      $("#refresh_new_threads").load(\' #refresh_new_threads\');
   }, {$interval} * 1000);
   $.ajaxSetup({ cache: false });
});
</script>';

    
    // Now check each of the themes
    $themequery = $db->simple_select("themes", "*");
    $sids = array();
    $first = true;
    while($theme = $db->fetch_array($themequery))
    {
        $properties = unserialize($theme['properties']);
        $sid = $properties['templateset'];
        if(!in_array($sid, $sids))
        {
            array_push($sids, $sid);

            foreach ($new_template as $title => $template)
            {
                $my_template = array(
                    'title' => $db->escape_string($title),
                    'template' => $db->escape_string($template),
                    'sid' => $sid,
                    'version' => '1800',
                    'dateline' => TIME_NOW);
                $db->insert_query('templates', $my_template);
                if($first)
                {
                    $my_new_template = array(
                        "title" => $db->escape_string($title),
                        "template" => $db->escape_string($template),
                        "sid" => -2,
                        "version" => "1814",
                        "dateline" => TIME_NOW
                    );
                    $db->insert_query("templates", $my_new_template);
                }
            }
            $first = false;
        }
    }

   require MYBB_ROOT.'/inc/adminfunctions_templates.php';

    find_replace_templatesets('index', "#" . preg_quote('{$forums}') . "#i", '{$forums}<div id="newthreads">{$newthreads}</div>');
    find_replace_templatesets('index', "#" . preg_quote('{$headerinclude}') . "#i", '{$headerinclude}{$newthreads_hi}<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">');

}

function newthreads_get_deactivate() 
{
    global $db;
    $template_array = array("newthreads", "newthreads_thread", "newthreads_avatar", "newthreads_headerinclude");
    $string = "";
    $comma = "";
    foreach($template_array as $name)
    {
        $string .= $comma . "'" . $name . "'";
        $comma = ",";
    }
    $db->delete_query("templates", "title IN(" . $string . ")");
    $db->delete_query("templategroups", "prefix='newthreads'");

   require MYBB_ROOT.'/inc/adminfunctions_templates.php';

    find_replace_templatesets('index', "#" . preg_quote('{$newthreads_hi}<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">') . "#i", '');
    find_replace_templatesets('index', "#" . preg_quote('<div id="newthreads">{$newthreads}</div>') . "#i", '');

}

?>