<?php
/***
 * New Threads
  ------
 * Created by: tyroklone
  ------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License, version 3, as 
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, visit <http://www.gnu.org/licenses/gpl.html>
 * 
 * Read More @License.txt File
***/

// disallow direct loading of this file
if (!defined("IN_MYBB")) {
  die("Direct loading of this file is not allowed.");
}

// Cache our templates
if(THIS_SCRIPT == 'index.php')
{
   global $templatelist;
   if(isset($templatelist))
   {
      $templatelist .= ',';
   }
   $templatelist .= 'newthreads,newthreads_thread,newthreads_avatar,newthreads_headerinclude';
}

$plugins->add_hook("index_end", "newthreads");
$plugins->add_hook("global_intermediate", "newthreads_intermediate");
$plugins->add_hook("xmlhttp", "newthreads_load_threads");

function newthreads($return=false)
{
   global $mybb, $db, $templates, $newthreads, $n_threads, $settings, $canviewnewthreads, $cache, $theme, $lang;

if($mybb->settings['newthreads_enable'] == 1)
{

// Fetch the current URL
$nt_url = get_current_location();
$nt_name = strtok(my_strtolower(basename($nt_url)), '?');

    // check permissions
    if(!newthreads_can_view())
    {
        return;
    }
    $lang->load("newthreads");

   $avatar_size = $mybb->settings['newthreads_avatar_size'];

        // Multipage alignment
        switch ($mybb->settings['newthreads_multi_align']) {
        case 1:
            $nt_align = "left";
            break;
        case 2:
            $nt_align = "center";
            break;
        case 3:
            $nt_align = "right";
            break;
        }

        // Newthreads order
        switch ($mybb->settings['newthreads_listing']) {
        case 1:
            $nt_order = "t.lastpost";
            break;
        case 2:
            $nt_order = "t.tid";
            break;
        case 3:
            $nt_order = "t.dateline";
            break;
        }

        // Newthreads arrangement format
        switch ($mybb->settings['newthreads_listing_order']) {
        case 1:
            $nt_format = "DESC";
            break;
        case 2:
            $nt_format = "ASC";
            break;
        }

   require_once MYBB_ROOT."inc/functions_search.php";
    $threadlimit = (int) $mybb->settings['newthreads_threadcount'];
    if(!$threadlimit) // Provide a fallback
    {
       $threadlimit = 15;
    }
   
   $onlyusfids = array();
   // Check group permissions if we can't view threads not started by us
   $group_permissions = forum_permissions();
   foreach($group_permissions as $fid => $forum_permissions)
   {
      if($forum_permissions['canonlyviewownthreads'] == 1)
      {
         $onlyusfids[] = $fid;
      }
   }
   if(!empty($onlyusfids))
   {
      $where .= "AND ((t.fid IN(".implode(',', $onlyusfids).") AND t.uid='{$mybb->user['uid']}') OR t.fid NOT IN(".implode(',', $onlyusfids)."))";
   }
   $approved = 0;
   
   // Moderators can view unapproved threads
   if($mybb->usergroup['canmodcp']==1) {
      $approved = -1;
   }
   $unsearchableforums = get_unsearchable_forums();
    $unviewableforums = get_unviewable_forums();
    if($unsearchableforums && $unviewableforums)
    {
        $forumarray = explode(",", $unsearchableforums . "," . $unviewableforums);
        $newarray = array_unique($forumarray);
        $unsearchableforumssql = " AND t.fid NOT IN(" . implode(",", $newarray) . ") ";
    }
    // Take into account any ignored forums
    if($mybb->settings['newthreads_forumskip'])
    {
        $ignoreforums = " AND t.fid NOT IN(" . $mybb->settings['newthreads_forumskip'] . ") ";
    }
    $forums = $cache->read("forums");

   // Let's add pagination / multipage
   $thread = get_thread($mybb->get_input('tid', MyBB::INPUT_INT));
   $threads_num = $db->fetch_field($db->simple_select('threads', 'COUNT(*) AS threads_num', "fid IN(2) AND visible='1' AND closed NOT LIKE 'moved|%'"), 'threads_num');
   $threads_pagenum = (int)$mybb->input['page'];
   $threads_totalpage = ceil($threads_num / $threadlimit);
   if($threads_pagenum < 1 || !$threads_pagenum || $threads_pagenum > $threads_totalpage){ $threads_pagenum = 1; }
   $multipage = multipage($threads_num, $threadlimit, $threads_pagenum, $nt_name);

   $query = $db->query("
         SELECT t.*, u.username AS userusername, u.usergroup, u.displaygroup, u.avatar as threadavatar, u.avatardimensions as threaddimensions, lp.usergroup AS lastusergroup, lp.avatar as lastavatar, lp.avatardimensions as lastdimensions, lp.displaygroup as lastdisplaygroup
         FROM ".TABLE_PREFIX."threads t
         LEFT JOIN ".TABLE_PREFIX."users u ON (u.uid=t.uid)
         LEFT JOIN ".TABLE_PREFIX."users lp ON (t.lastposteruid=lp.uid)
         WHERE 1=1 $where AND t.visible > {$approved} {$unsearchableforumssql} {$ignoreforums}
         ORDER BY {$nt_order} {$nt_format}
         LIMIT 0".(($threads_pagenum-1)*$threadlimit).", ".$threadlimit
      );
      while($thread = $db->fetch_array($query))
      {
            $trow = alt_trow();
            $thread['forum'] = $forums[$thread['fid']]['name'];
            $threadlink = get_thread_link($thread['tid'], "", "newpost");
            $thread['forumlink'] = get_forum_link($thread['fid']);
            $lastpostlink = get_thread_link($thread['tid'], "", "lastpost");
            $relativetime = my_date("relative", $thread['dateline']);
         $lastposter = $thread['lastposter'];
         $lastposteruid = $thread['lastposteruid'];
         $thread['author'] = build_profile_link(format_name($thread['userusername'], $thread['usergroup'], $thread['displaygroup']), $thread['uid']);
         // Don't link to guest's profiles (they have no profile).
         if($lastposteruid == 0)
         {
            $lastposterlink = $lastposter;
         }
         else
         {
            $lastposterlink = build_profile_link(format_name($lastposter, $thread['lastusergroup'], $thread['lastdisplaygroup']), $lastposteruid);
         }
            if($mybb->settings['newthreads_threadavatar'] == 1)
            {
                $threadavatar = format_avatar($thread['threadavatar'], $thread['threaddimensions']);
                $avatarurl = $threadavatar['image'];
                $dimensions = $threadavatar['width_height'];
                eval("\$author_avatar = \"".$templates->get("newthreads_avatar")."\";");
            }
            if($mybb->settings['newthreads_threadavatar'] == 2)
            {
                $lastposteravatar = format_avatar($thread['lastavatar'], $thread['lastdimensions']);
                $avatarurl = $lastposteravatar['image'];
                $dimensions = $lastposteravatar['width_height'];
                eval("\$lastposter_avatar = \"".$templates->get("newthreads_avatar")."\";");
            }
            // Now check the length of subjects
            $length = (int) $mybb->settings['newthreads_subject_length'];
            if(strlen($thread['subject']) > $length && $length != 0)
            {
                // Figure out if we need to split it up.
                $title = my_substr($thread['subject'], 0, $length);
                if($mybb->settings['newthreads_subject_breaker'])
                {
                    $words = explode(" ", $title);
                    $count = count($words) -1;
                    $currenttitle = "";
                    for($x = 0; $x < $count; $x++)
                    {
                        $currenttitle .= $words[$x] . " ";
                    }
                    $thread['subject'] = $currenttitle . " ...";
                }
                if(!$mybb->settings['newthreads_subject_breaker'])
                {
                    $thread['subject'] = $title . "...";
                }
            }

            // Moderator capabilities
            if(is_moderator($thread['fid']))
            {
                $ismod = TRUE;
                // fetch the inline mod column
            }
            else
            {
                $ismod = FALSE;
            }
            if(is_moderator($thread['fid'], "caneditposts") || $fpermissions['caneditposts'] == 1)
            {
               $can_edit_titles = 1;
            }
            else
            {
               $can_edit_titles = 0;
            }
            $inline_edit_class = '';
          if(($thread['uid'] == $mybb->user['uid'] && $thread['closed'] != 1 && $mybb->user['uid'] != 0 && $can_edit_titles == 1) || $ismod == true)
          {
             $inline_edit_class = "subject_editable";
          }

         eval("\$n_threads .= \"".$templates->get("newthreads_thread")."\";");
            unset($author_avatar);
            unset($lastposter_avatar);
      }
        eval("\$newthreads = \"".$templates->get("newthreads")."\";");
        if($return)
        {
            return $newthreads;
        }
    }
}

function newthreads_intermediate()
{
    global $templates, $newthreads_hi, $interval;

   $interval = $mybb->settings['newthreads_interval'];
    if(THIS_SCRIPT == "index.php" && newthreads_can_view())
    {
        eval("\$newthreads_hi = \"".$templates->get("newthreads_headerinclude")."\";");
    }
}

function newthreads_load_threads()
{
    global $db, $mybb, $canviewnewthreads;

    if($mybb->input['action'] == "new_threads")
    {
        require_once MYBB_ROOT . "/inc/plugins/newthreads.php";
        if(newthreads_can_view())
        {
            echo(newthreads(true));
        }
        die;
    }
}

function newthreads_can_view()
{
    global $mybb, $interval;
   
   $interval = $mybb->settings['newthreads_interval'];
    if($mybb->settings['newthreads_which_groups'])
    {
        $disallowedgroups = explode(",", $mybb->settings['newthreads_which_groups']);
        $mygroups = $mybb->user['usergroup'];
        if($mybb->user['additionalgroups'])
        {
            $mygroups .= "," . $mybb->user['additionalgroups'];
        }
        $groups = explode(",", $mygroups);
        foreach($groups as $group)
        {
            if(in_array($group, $disallowedgroups))
            {
                return FALSE;
            }
        }
        return TRUE;
    }
    else
    {
         return TRUE;
    }
}
?>