<?php
/***
 * New Threads
  ------
 * Created by: tyroklone
  ------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License, version 3, as 
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, visit <http://www.gnu.org/licenses/gpl.html>
 * 
 * Read More @License.txt File
***/

// disallow direct loading of this file
if (!defined("IN_MYBB")) {
  die("Direct loading of this file is not allowed.");
}

function newthreads_get_install()
{
   global $db, $mybb, $lang;
   $lang->load('newthreads');

    if($mybb->version_code < 1800)
    {
        flash_message($lang->mybb_compat_msg, "error");
        admin_redirect("index.php?module=config-plugins");
    }

  $new_setting_group = array(
    "name" => "newthreads", 
    "title" => $lang->nt_sg_title, 
    "description" => $lang->nt_sg_desc, 
    "disporder" => -1, 
    "isdefault" => 0
  );

    $gid = $db->insert_query("settinggroups", $new_setting_group);

  // ***********************************************
  // create plugin settings
  // ***********************************************
  // newthreads enable
  $new_setting[] = array(
    "name" => "newthreads_enable", 
    "title" => $lang->nt_enable, 
    "description" => $lang->nt_enable_desc, 
    "optionscode" => "yesno", 
    "value" => 1, 
    "disporder" => 1, 
    "gid" => $gid
  );

  // thread count
  $new_setting[] = array(
    "name" => "newthreads_threadcount", 
    "title" => $lang->nt_tcount, 
    "description" => $lang->nt_tcount_desc, 
    "optionscode" => "numeric", 
    "value" => 15, 
    "disporder" => 2, 
    "gid" => $gid
  );

  // thread listing
  $new_setting[] = array(
    "name" => "newthreads_listing", 
    "title" => $lang->nt_listing, 
    "description" => $lang->nt_listing_desc,
    "optionscode" => "select \n 1=List By Lastpost \n 2=List By Thread ID \n 3=List By Date / Time", 
    "value" => 1, 
    "disporder" => 3, 
    "gid" => $gid
  );

  // thread listing order
  $new_setting[] = array(
    "name" => "newthreads_listing_order", 
    "title" => $lang->nt_lorder, 
    "description" => $lang->nt_lorder_desc,
    "optionscode" => "select \n 1= Ascending Order \n 2=Descending Order", 
    "value" => 2, 
    "disporder" => 4, 
    "gid" => $gid
  );

  // multipage alignment
  $new_setting[] = array(
    "name" => "newthreads_multi_align", 
    "title" => $lang->nt_malign, 
    "description" => $lang->nt_malign_desc,
    "optionscode" => "radio \r\n 1=Left \r\n 2=Center \r\n 3=Right", 
    "value" => 1, 
    "disporder" => 5, 
    "gid" => $gid
  );

  // thread avatar
  $new_setting[] = array(
    "name" => "newthreads_threadavatar", 
    "title" => $lang->nt_tavatar, 
    "description" => $lang->nt_tavatar_desc,
    "optionscode" => "select \n 1=Author Avatar \n 2=Last Poster Avatar \n 3=No Avatar", 
    "value" => 3, 
    "disporder" => 6, 
    "gid" => $gid
  );

  // thread avatar size
  $new_setting[] = array(
    "name" => "newthreads_avatar_size", 
    "title" => $lang->nt_asize, 
    "description" => $lang->nt_asize_desc,
    "optionscode" => "numeric", 
    "value" => 40, 
    "disporder" => 7, 
    "gid" => $gid
  );

  // forum skip
  $new_setting[] = array(
    "name" => "newthreads_forumskip", 
    "title" => $lang->nt_fskip, 
    "description" => $lang->nt_fskip_desc, 
    "optionscode" => "forumselect", 
    "value" => "", 
    "disporder" => 8, 
    "gid" => $gid
  );

  // subject breaker
  $new_setting[] = array(
    "name" => "newthreads_subject_breaker", 
    "title" => $lang->nt_sbreaker, 
    "description" => $lang->nt_sbreaker_desc, 
    "optionscode" => "yesno", 
    "value" => 0, 
    "disporder" => 9, 
    "gid" => $gid
  );

  // subject length
  $new_setting[] = array(
    "name" => "newthreads_subject_length", 
    "title" => $lang->nt_slength, 
    "description" => $lang->nt_slength_desc,
    "optionscode" => "numeric", 
    "value" => 0, 
    "disporder" => 10, 
    "gid" => $gid
  );

  // which groups
  $new_setting[] = array(
    "name" => "newthreads_which_groups", 
    "title" => $lang->nt_wgroups, 
    "description" => $lang->nt_wgroups_desc, 
    "optionscode" => "groupselect", 
    "value" => 7, 
    "disporder" => 11, 
    "gid" => $gid
  );

  // newthreads interval
  $new_setting[] = array(
    "name" => "newthreads_interval", 
    "title" => $lang->nt_interval, 
    "description" => $lang->nt_interval_desc, 
    "optionscode" => "text", 
    "value" => 30, 
    "disporder" => 12, 
    "gid" => $gid
  );

    $db->insert_query_multiple("settings", $new_setting);

  rebuild_settings();
      
}

?>